import '../assets/styles/main.css'
import '../assets/iconfont/iconfont.css'
import {
  ElScrollbar,
  ElMenu,
  ElMenuItem,
  ElSubmenu,
  ElBreadcrumb,
  ElBreadcrumbItem,
  ElTabs,
  ElTabPane,
  ElButton,
  ElDropdown,
  ElDropdownMenu,
  ElDropdownItem,
  ElBadge,
  ElDrawer,
  ElDivider,
  ElRow,
  ElCol,
  ElSwitch,
  ElCard,
  ElPopover,
  ElInput
} from 'element-plus'
import store from '../store'

function registerElement(app) {
  app.use(ElScrollbar)
    .use(ElMenu)
    .use(ElMenuItem)
    .use(ElSubmenu)
    .use(ElBreadcrumb)
    .use(ElBreadcrumbItem)
    .use(ElTabs)
    .use(ElTabPane)
    .use(ElButton)
    .use(ElDropdown)
    .use(ElDropdownMenu)
    .use(ElDropdownItem)
    .use(ElCard)
    .use(ElBadge)
    .use(ElPopover)
    .use(ElDrawer)
    .use(ElDivider)
    .use(ElRow)
    .use(ElCol)
    .use(ElSwitch)
    .use(ElInput)
}

export function registerComponents(app) {
  const components = require.context('./', true, /\.vue$/)
  components.keys().forEach(it => {
    const component = components(it)
    app.component(component.default.name, component.default)
  })
}

function install(Vue, options) {
  registerComponents(Vue)
  if (options && options.registerElement === false) {
    console.warn('element-plus components not be registed, please check `registerElement` is `false`')
  } else {
    registerElement(Vue)
  }
  delete options.registerElement
  store.start(options)
  Vue.config.globalProperties.$layoutStore = store
}

store.install = install

export { default as Layout } from './Layout.vue'

export default store
